{
  "openapi": "3.1.2",
  "jsonSchemaDialect": "https://spec.openapis.org/oas/3.1/dialect/base",
  "info": {
    "version": "0.0.0",
    "title": "Billogram - OpenAPI 3.1",
    "contact": {
      "email": "support@billogram.com"
    },
    "description": "The Billogram API is a RESTful JSON API for managing invoices, customers, and billing operations.\nAll requests must be made over HTTPS and authenticated with HTTP Basic Auth.\n\nFor a conceptual introduction and quickstart, see the [Getting Started](/guides/getting-started) guide.\nFor authentication details, see [Authentication](/guides/authentication).\nFor request and response conventions, see [Requests & Responses](/guides/requests-and-responses)."
  },
  "servers": [
    {
      "url": "https://sandbox.billogram.com/api/v2",
      "description": "Sandbox server (uses test data)"
    },
    {
      "url": "https://billogram.com/api/v2",
      "description": "Production server (uses live data)"
    }
  ],
  "tags": [
    {
      "name": "Billogram",
      "description": "A billogram is a collection of related invoices, and the base information used to create them. \nTo invoice a customer, you create a billogram with the items to be invoiced for, \nassign the customer to it, and attest it by performing the send command. \nThis generates an initial invoice to the customer. \nIf circumstances later change and you need to e.g. credit part of the invoice, \nthe credit invoice for this will be added to the same billogram, keeping related information together. \nThe billogram object also lets you change the items invoiced for after sending the invoice, \nin this case the Billogram service will intelligently create additional regular invoices \nand credit invoices as required to ensure the customer pays the correct amount.\n\nIn the Billogram system, invoices are represented as sub-objects of billogram objects, \nand invoices are immutable. Changes to the billogram object will rather generate new invoices.\n\nA billogram object also contains a complete history of all activity relating to it, \nsuch as it being created, invoices sent, payments received, reminders sent, and so on.\n"
    },
    {
      "name": "Customer",
      "description": "Customers are registered recipients of invoices, invoices can only be sent to an existing customer.\n\nThe *company_type* field of a customer determines the customer's legal status; \nwhether they are a private person or a business, \nand whether they reside in the Billogram business account's country or not. \nThis information controls the availability of some of the invoicing features, \nfor instance the ROT/RUT deduction options are only available when a Swedish business is invoicing a Swedish private customer, \nnot when they invoice a foreign customer or another business.\n"
    },
    {
      "name": "Item",
      "description": "An item is a product or service that can be invoiced for. \nOn an invoice, they appear as a row with a text, a unit price, \na (possibly fractional) number of units invoiced for, and the calculated total cost.\n"
    },
    {
      "name": "Stand-alone credit invoices",
      "description": "In Billogram, **default credits** are credit invoices created within an existing billogram\nthat already contains a debit invoice. These credits are automatically allocated to the\ndebit invoice within that billogram.\n\n**Stand-alone credits** are credit invoices created as isolated billograms.\nThey can be allocated to one or several debit invoices on other billograms\nfor the same customer, providing greater flexibility (for example in B2B scenarios).\n\n### Key characteristics\n- Always have a **negative sum**\n- Cannot be converted into debit invoices\n- Can be allocated across multiple billograms\n- Can be marked as paid out via the payment function\n- Must be enabled by Billogram upon request\n- Supports the `DoNotNotify` delivery method\n- `reference_invoice_no` must be the original invoice's real invoice number\n  (not an internal reference). **Required when sending** a stand-alone credit\n  on a French-market creditor. `reference_invoice_date` is optional.\n"
    },
    {
      "name": "Payment Sources",
      "description": "A payment source is something where funds can be requested / drawn from to for allocation towards a payable. \nIt is a deliberate abstraction of different concrete payment schemes like \nAutogiro, AvtaleGiro, SEPA Direct Debit, etc.\n\nPayment sources can be used to authorize withdrawal of funds from an underlying account, \nin these cases an underlying mandate will exist, \nthe structure of these will vary by the requirements of the underlying scheme.\n"
    },
    {
      "name": "Offer",
      "description": "Offers can be attached to invoices to expand branding opportunities or sell products/services.\nThere are two offer types:\n- `banner`: links to an external URL\n- `sale`: opens an overlay and can be accepted by the recipient\n"
    },
    {
      "name": "Billing Tab",
      "description": "The **Billing Tab** feature lets you add items to a customer's ongoing “tab”.\nAt a scheduled date, Billogram automatically creates an invoice containing all items currently on the tab.\n\n### How it works\n1. **Add items over time** – Add separate items as they are sold/provided.\n2. **Accumulate items** – Items accumulate on the tab until the scheduled billing date.\n3. **Automatic invoice creation** – A single invoice is created at the scheduled date.\n4. **Tab reset** – The tab is emptied for the next billing period.\n\n### Components\n- **Billing Tab** – The customer's accumulated items that will be invoiced together\n- **Billing Tab Items** – Individual items added over time\n- **Customer Settings** – Per-customer billing frequency and delivery method\n\n### Validation rules\n- `customer_no` must be numeric (digits only); invalid input returns **400**.\n- `billing_tab_id` and `billing_tab_item_id` must be valid UUIDs; invalid format returns **400**.\n- Creating a billing-tab item requires `billogram_item`.\n- Customer settings require at least one of `billing_frequency` or `delivery_method`.\n"
    },
    {
      "name": "Settings",
      "description": "The settings object lets a client application modify global values for a Billogram business account.\nThese settings are also available on the web interface;\nmost applications may never need to use the settings object.\n"
    },
    {
      "name": "Report",
      "description": "Your report files are available for fetching via the API. \nFor the reports resource, you should use the `filename` attribute as ID.\nNote that this is a read-only resource, you cannot modify any reports\n"
    },
    {
      "name": "Webhooks",
      "description": "Webhooks allow you to receive real-time HTTP POST notifications about events in your Billogram account.\nIn the API schema, these are referred to as `callbacks` for historical reasons.\n\nFor configuration, signature verification, event types, and best practices,\nsee the [Webhooks guide](/guides/webhooks).\n"
    }
  ],
  "security": [
    {
      "basicAuth": []
    }
  ],
  "paths": {
    "/billogram": {
      "post": {
        "operationId": "createBillogram",
        "summary": "Create a new billogram object",
        "description": "Create a new billogram object",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Billogram"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/AssetNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "503": {
            "$ref": "#/components/responses/ServiceUnavailable"
          }
        },
        "tags": [
          "Billogram"
        ]
      },
      "get": {
        "operationId": "listBillograms",
        "summary": "Search for billograms",
        "description": "List/search billogram objects with optional filtering and pagination",
        "parameters": [
          {
            "name": "page",
            "in": "query",
            "description": "The result page number to fetch. The first page has number 1 (one).",
            "required": true,
            "schema": {
              "type": "integer",
              "minimum": 1,
              "default": 1
            }
          },
          {
            "name": "page_size",
            "in": "query",
            "description": "How many results to return per page. Settings this number too high may impact performance, we recommend values between 10 and 100.",
            "required": true,
            "schema": {
              "type": "integer",
              "minimum": 1,
              "maximum": 100,
              "default": 25
            }
          },
          {
            "name": "filter_type",
            "in": "query",
            "description": "Type of filtering to perform",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "field",
                "field-prefix",
                "field-search"
              ]
            }
          },
          {
            "name": "filter_field",
            "in": "query",
            "description": "Field to filter on when using field-based filtering",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "filter_value",
            "in": "query",
            "description": "Value to filter by when using field-based filtering",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "order_field",
            "in": "query",
            "description": "Field to order results by",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "order_direction",
            "in": "query",
            "description": "Direction to order results",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "asc",
                "desc"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillogramList"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGateway"
          },
          "504": {
            "$ref": "#/components/responses/GatewayTimeout"
          }
        },
        "tags": [
          "Billogram"
        ]
      }
    },
    "/billogram/{id}": {
      "get": {
        "operationId": "getBillogram",
        "summary": "Fetch a single billogram object",
        "description": "Fetch a single billogram object",
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "404": {
            "$ref": "#/components/responses/BillogramNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        },
        "tags": [
          "Billogram"
        ]
      },
      "put": {
        "operationId": "updateBillogram",
        "summary": "Update a billogram object",
        "description": "Update a billogram object",
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Billogram"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "404": {
            "$ref": "#/components/responses/BillogramNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGateway"
          }
        },
        "tags": [
          "Billogram"
        ]
      },
      "delete": {
        "operationId": "deleteBillogram",
        "summary": "Delete a billogram draft",
        "description": "Permanently deletes a billogram that is still a draft. Only allowed when the billogram is in state `Billogram_State_Unattested`. For any other state, the API returns `INVALID_OBJECT_STATE` with a message indicating that the Delete event is not supported in the current state.\n",
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "description": "OK. The draft billogram was deleted.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "status",
                    "data"
                  ],
                  "properties": {
                    "status": {
                      "type": "string",
                      "enum": [
                        "OK"
                      ]
                    },
                    "data": {
                      "type": "object",
                      "additionalProperties": false
                    }
                  }
                },
                "example": {
                  "status": "OK",
                  "data": {}
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequestDeleteBillogram"
          },
          "404": {
            "$ref": "#/components/responses/BillogramNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        },
        "tags": [
          "Billogram"
        ]
      }
    },
    "/billogram/{id}.pdf": {
      "get": {
        "operationId": "getBillogramPdf",
        "summary": "Fetch generated PDF for a Billogram object",
        "description": "Fetch generated PDF for a Billogram object",
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillogramNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        },
        "tags": [
          "Billogram"
        ]
      }
    },
    "/billogram/{id}/attachment.pdf": {
      "get": {
        "operationId": "getBillogramAttachment",
        "tags": [
          "Billogram"
        ],
        "summary": "Get billogram PDF attachment metadata and content",
        "description": "Fetch the billogram attachment (if present).\n\nReturns a JSON response with:\n- `file_type` (e.g. `application/pdf`)\n- `filename`\n- `content` (base64-encoded file content)\n",
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "description": "Attachment was returned successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BillogramAttachmentResponse"
                },
                "example": {
                  "status": "OK",
                  "data": {
                    "file_type": "application/pdf",
                    "content": "",
                    "filename": "attachment_filename.pdf"
                  }
                }
              }
            }
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillogramNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/billogram/{id}/command/send": {
      "post": {
        "operationId": "sendBillogram",
        "summary": "Send a billogram",
        "description": "Send (attest) a billogram, generating an invoice that will be delivered to the recipient. The chosen delivery method must be valid for the billogram's market and creditor configuration.\n",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/SendBillogramRequest"
              },
              "example": {
                "method": "Letter"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequestSendBillogram"
          },
          "403": {
            "$ref": "#/components/responses/ForbiddenSendBillogram"
          },
          "404": {
            "$ref": "#/components/responses/BillogramNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGateway"
          },
          "504": {
            "$ref": "#/components/responses/GatewayTimeout"
          }
        }
      }
    },
    "/billogram/{id}/command/resend": {
      "post": {
        "operationId": "resendBillogram",
        "summary": "Resend a billogram",
        "description": "Resend a previously sent billogram. Request body is optional. If omitted, the original delivery method will be used.\n",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": false,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ResendBillogramRequest"
              },
              "example": {
                "method": "Email"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequestResendBillogram"
          },
          "404": {
            "$ref": "#/components/responses/BillogramNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/billogram/{id}/command/remind": {
      "post": {
        "operationId": "remindBillogram",
        "summary": "Send a reminder",
        "description": "Send a reminder for a billogram, only possible after the due date has passed.\n",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": false,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RemindBillogramRequest"
              },
              "example": {
                "method": "Email",
                "message": "This is a payment reminder.",
                "due_days": 0
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequestRemindBillogram"
          },
          "403": {
            "$ref": "#/components/responses/ForbiddenRemindBillogram"
          },
          "404": {
            "$ref": "#/components/responses/BillogramNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          },
          "504": {
            "$ref": "#/components/responses/GatewayTimeout"
          }
        }
      }
    },
    "/billogram/{id}/command/collect": {
      "post": {
        "operationId": "collectBillogram",
        "summary": "Send to collection",
        "description": "Send a billogram to debt collection.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/sell": {
      "post": {
        "operationId": "sellBillogram",
        "summary": "Sell a billogram",
        "description": "Sell a billogram to a third party.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/payment": {
      "post": {
        "operationId": "registerPayment",
        "summary": "Register a payment",
        "description": "Manually register a payment on a billogram. This is intended to be used if a payment is received outside the services offered by Billogram, e.g. if the customer pays by cash rather than via the Billogram client funds accounts.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/PaymentCommand"
              },
              "example": {
                "amount": 100,
                "payment_date": "2026-01-01"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/settle-underpayment": {
      "post": {
        "operationId": "settleUnderpayment",
        "summary": "Settle underpayment",
        "description": "Settle an underpayment on a billogram when the payer has paid less than the full amount due, reconciling the remaining balance accordingly.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/credit": {
      "post": {
        "operationId": "creditBillogram",
        "summary": "Credit a billogram",
        "description": "Credit a billogram, either fully or partially by specifying items to credit.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BillogramCreditCommand"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/writeoff": {
      "post": {
        "operationId": "writeoffBillogram",
        "summary": "Write off overdue charges",
        "description": "Remove remaining overdue charges from a billogram, such as reminder fees and late payment interest. This is useful if you have a billogram which is fully paid and you want to remove remaining overdue charges.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": false,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/WriteoffCommand"
              },
              "example": {
                "allow_unpaid": true
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/writedown": {
      "post": {
        "operationId": "writedownBillogram",
        "summary": "Write down a billogram",
        "description": "Write down a billogram, reducing its value and marking it as expected loss.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/revert-writedown": {
      "post": {
        "operationId": "revertWritedown",
        "summary": "Revert a write down",
        "description": "Revert a previous write down operation on a billogram.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/confirmed-loss": {
      "post": {
        "operationId": "markConfirmedLoss",
        "summary": "Mark as confirmed loss",
        "description": "Mark a billogram as a confirmed loss.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/respite": {
      "post": {
        "operationId": "setRespite",
        "summary": "Grant a respite",
        "description": "Grant a respite period for a billogram, allowing payment after the due date without triggering reminders. Any existing scheduled direct debit payment will be rescheduled to the respite date.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "description": "The date until which the respite is granted.",
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "required": [
                  "date"
                ],
                "properties": {
                  "date": {
                    "type": "string",
                    "format": "date",
                    "description": "The new respite date. Must be later than the current due date."
                  }
                }
              },
              "example": {
                "date": "2026-01-31"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/remove-respite": {
      "post": {
        "operationId": "removeRespite",
        "summary": "Remove a respite",
        "description": "Remove an active respite period from a billogram.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/message": {
      "post": {
        "operationId": "addMessage",
        "summary": "Add a message",
        "description": "Add a message to the conversation on the billogram. The message will be delivered via email.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/MessageCommand"
              },
              "example": {
                "message": "Please contact us regarding your invoice."
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/attach": {
      "post": {
        "operationId": "attachPdf",
        "summary": "Attach a PDF file",
        "description": "Attach a PDF attachment to a billogram.  The PDF attachment will be printed and sent along with the invoice if delivered by letter  and will be available to download when the recipient receives the billogram via email or link. The attachment can later be fetched from the target path billogram/{id}/attachment.pdf. To remove an attachment, update the attachment field of the billogram to null.",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AttachCommand"
              },
              "example": {
                "filename": "terms.pdf",
                "content": "JVBERi0xLjQKJeLjz9MKMSAwIG9iago8PAovVHlwZSAvQ2F0YWxvZwo+PgplbmRvYmoKdHJhaWxlcgo8PAovUm9vdCAxIDAgUgo+PgolJUVPRgo="
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/credit-allocate": {
      "post": {
        "operationId": "creditAllocate",
        "summary": "Allocate credit invoice",
        "description": "Allocate a stand-alone credit invoice to a debit invoice. Specify the billogram on which you want to allocate a stand-alone credit invoice in the path and the billogram from which you want to allocate in the payload as source_id.",
        "tags": [
          "Stand-alone credit invoices"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreditAllocateCommand"
              },
              "example": {
                "amount": 500,
                "source_id": "CDAEyKE"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram/{id}/command/credit-payment": {
      "post": {
        "operationId": "creditPayment",
        "summary": "Register credit payment",
        "description": "Register a payment on a stand-alone credit invoice. Use mode 'remaining' to register the full remaining amount, or mode 'amount' to specify a custom payment amount.",
        "tags": [
          "Stand-alone credit invoices"
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/BillogramId"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreditPaymentCommand"
              },
              "example": {
                "mode": "amount",
                "amount": 250
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Billogram"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/billogram_event": {
      "get": {
        "operationId": "getBillogramEvents",
        "summary": "Get billogram events",
        "description": "If you need more than the 100 latest history events for a billogram,\nyou may query the `/api/v2/billogram_event` resource.\n\nYou may only GET (list/search) from this resource by using field-based filtering where\n`filter_type` is set to `\"field\"`, `filter_field` is set to `\"billogram_id\"`, and\n`filter_value` is the id of the billogram you wish to get events from.\n\nThe list is sorted by creation time (`created_at`). By default, results are returned in\nascending order starting with the oldest event as the first object (typically the\n`BillogramCreated` event), but you can change the ordering by using the `order_direction`\nquery parameter together with `order_field`.\n\nThere is no way to perform a `GET` for a single event, since the events do not have any\nunique ids returned.\n",
        "tags": [
          "Billogram"
        ],
        "parameters": [
          {
            "name": "page",
            "in": "query",
            "description": "The result page number to fetch. The first page has number 1 (one).",
            "schema": {
              "type": "integer",
              "minimum": 1,
              "default": 1
            }
          },
          {
            "name": "page_size",
            "in": "query",
            "description": "How many results to return per page. Setting this number too high may impact performance, we recommend values between 10 and 100.",
            "schema": {
              "type": "integer",
              "minimum": 1,
              "maximum": 100,
              "default": 25
            }
          },
          {
            "name": "filter_type",
            "in": "query",
            "description": "Type of filtering to perform",
            "schema": {
              "type": "string",
              "enum": [
                "field"
              ]
            }
          },
          {
            "name": "filter_field",
            "in": "query",
            "description": "Field to filter on when using field-based filtering. \nbillogram_id is the only supported field.\n",
            "schema": {
              "type": "string",
              "enum": [
                "billogram_id"
              ]
            }
          },
          {
            "name": "filter_value",
            "in": "query",
            "description": "Value to filter by when using field-based filtering.\nThe value must be the id of the billogram you wish to get events from.\n",
            "schema": {
              "type": "string"
            }
          },
          {
            "in": "query",
            "name": "order_field",
            "schema": {
              "type": "string",
              "enum": [
                "created_at"
              ]
            },
            "description": "Name of the field to order the results by. \ncreated_at is the only supported field.\n"
          },
          {
            "in": "query",
            "name": "order_direction",
            "schema": {
              "type": "string",
              "enum": [
                "asc",
                "desc"
              ]
            },
            "description": "Whether to use ascending or descending ordering for the field specified."
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillogramEventList"
          },
          "400": {
            "description": "Bad Request - The request was invalid or cannot be otherwise served.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "InvalidQueryParameter": {
                    "$ref": "#/components/examples/InvalidQueryParameter"
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not Found - The requested resource was not found.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "BillogramNotFound": {
                    "$ref": "#/components/examples/BillogramNotFound"
                  }
                }
              }
            }
          }
        }
      }
    },
    "/customer": {
      "post": {
        "operationId": "createCustomer",
        "summary": "Create a customer",
        "description": "Create a new customer",
        "tags": [
          "Customer"
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "examples": {
                "default": {
                  "$ref": "#/components/examples/Customer"
                }
              },
              "schema": {
                "$ref": "#/components/schemas/Customer"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK. The customer was created successfully. The data of the response contains the actual customer object created in the database, including any auto-generated customer_no value.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string"
                    },
                    "data": {
                      "$ref": "#/components/schemas/Customer"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      },
      "get": {
        "operationId": "listCustomers",
        "summary": "List customers",
        "description": "Search for customers",
        "tags": [
          "Customer"
        ],
        "parameters": [
          {
            "in": "query",
            "name": "page",
            "schema": {
              "type": "integer",
              "minimum": 1,
              "default": 1
            },
            "required": true,
            "description": "The result page number to fetch. The first page has number 1 (one)."
          },
          {
            "in": "query",
            "name": "page_size",
            "schema": {
              "type": "integer",
              "minimum": 1,
              "maximum": 100,
              "default": 25
            },
            "required": true,
            "description": "How many results to return per page. Settings this number too high may impact performance, we recommend values between 10 and 100."
          },
          {
            "in": "query",
            "name": "filter_type",
            "schema": {
              "type": "string",
              "enum": [
                "field",
                "field-prefix",
                "field-search",
                "special"
              ]
            },
            "description": "The kind of search to perform."
          },
          {
            "in": "query",
            "name": "filter_field",
            "schema": {
              "type": "string"
            },
            "description": "Name of the field to search in. The available fields depends on the className the request is made to."
          },
          {
            "in": "query",
            "name": "filter_value",
            "schema": {
              "type": "string"
            },
            "description": "The value to search for."
          },
          {
            "in": "query",
            "name": "order_field",
            "schema": {
              "type": "string"
            },
            "description": "Name of the field to order the results by. The available fields depends on the className the request is made to."
          },
          {
            "in": "query",
            "name": "order_direction",
            "schema": {
              "type": "string",
              "enum": [
                "asc",
                "desc"
              ]
            },
            "description": "Whether to use ascending or descending ordering for the field specified."
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string"
                    },
                    "data": {
                      "type": "array",
                      "items": {
                        "$ref": "#/components/schemas/Customer"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          }
        }
      }
    },
    "/customer/{customer_no}": {
      "get": {
        "operationId": "getCustomer",
        "summary": "Get a customer",
        "description": "Fetch a single customer object",
        "tags": [
          "Customer"
        ],
        "parameters": [
          {
            "name": "customer_no",
            "in": "path",
            "description": "Customer ID",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "The customer was found. The data of the response contains the requested customer object's current state.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string"
                    },
                    "data": {
                      "$ref": "#/components/schemas/Customer"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "$ref": "#/components/responses/CustomerNotFound"
          }
        }
      },
      "put": {
        "operationId": "updateCustomer",
        "summary": "Update a customer",
        "description": "Update a customer object",
        "tags": [
          "Customer"
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "examples": {
                "default": {
                  "$ref": "#/components/examples/Customer"
                }
              },
              "schema": {
                "$ref": "#/components/schemas/Customer"
              }
            }
          }
        },
        "parameters": [
          {
            "name": "customer_no",
            "in": "path",
            "description": "Customer ID",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful operation",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string"
                    },
                    "data": {
                      "$ref": "#/components/schemas/Customer"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "404": {
            "$ref": "#/components/responses/CustomerNotFound"
          }
        }
      }
    },
    "/customer/{customer_no}/balance": {
      "get": {
        "operationId": "getCustomerBalance",
        "summary": "Get customer balance",
        "description": "Fetch the customer's balance totals from the customer balance ledger header.\n\nReturns total outstanding, net balance excluding doubtful debt, and doubtful debt total.\nThese amounts match the totals shown in the creditor UI for the customer.\n\nRequires the `customer_balance:enabled` creditor feature flag and a\n`creditor-admin` or `creditor-support` API user.\n",
        "tags": [
          "Customer"
        ],
        "parameters": [
          {
            "name": "customer_no",
            "in": "path",
            "description": "Customer ID",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "The customer balance was retrieved.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "status",
                    "data"
                  ],
                  "properties": {
                    "status": {
                      "type": "string"
                    },
                    "data": {
                      "$ref": "#/components/schemas/CustomerBalance"
                    }
                  }
                },
                "examples": {
                  "default": {
                    "value": {
                      "status": "OK",
                      "data": {
                        "total_outstanding": {
                          "value": "4.50",
                          "currency": "EUR"
                        },
                        "net_balance": {
                          "value": "4.50",
                          "currency": "EUR"
                        },
                        "doubtful_debt": {
                          "value": "0.00",
                          "currency": "EUR"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/CustomerNotFound"
          }
        }
      }
    },
    "/customer/{customer_no}/einvoice": {
      "parameters": [
        {
          "name": "customer_no",
          "in": "path",
          "required": true,
          "description": "Customer ID.",
          "schema": {
            "type": "string"
          }
        }
      ],
      "get": {
        "operationId": "getCustomerEinvoiceRegistration",
        "tags": [
          "Customer"
        ],
        "summary": "Get customer e-invoice registration",
        "description": "Fetch the customer's e-invoice registration (if any).\n\n**Availability**\n- Markets: Sweden, Norway, Finland, Italy\n\n**Notes**\n- Returns the current registration data structure.\n",
        "responses": {
          "200": {
            "description": "The customer registration was found.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "status",
                    "data"
                  ],
                  "properties": {
                    "status": {
                      "type": "string",
                      "description": "Operation status."
                    },
                    "data": {
                      "$ref": "#/components/schemas/CustomerEinvoiceRegistration"
                    }
                  }
                },
                "examples": {
                  "Sweden": {
                    "$ref": "#/components/examples/CustomerEinvoiceRegistrationSweden"
                  },
                  "Italy": {
                    "$ref": "#/components/examples/CustomerEinvoiceRegistrationItaly"
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/CustomerNotFound"
          }
        }
      },
      "post": {
        "operationId": "createCustomerEinvoiceRegistration",
        "tags": [
          "Customer"
        ],
        "summary": "Create customer e-invoice registration",
        "description": "Create an e-invoice registration for a customer.\n\n**Availability**\n- Markets: Sweden, Italy\n",
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CustomerEinvoiceRegistrationRequest"
              },
              "examples": {
                "Sweden": {
                  "$ref": "#/components/examples/CustomerEinvoiceRegistrationRequestSweden"
                },
                "Italy": {
                  "$ref": "#/components/examples/CustomerEinvoiceRegistrationRequestItaly"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "The customer registration was created.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "status",
                    "data"
                  ],
                  "properties": {
                    "status": {
                      "type": "string"
                    },
                    "data": {
                      "$ref": "#/components/schemas/CustomerEinvoiceRegistration"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/CustomerNotFound"
          }
        }
      },
      "put": {
        "operationId": "updateCustomerEinvoiceRegistration",
        "tags": [
          "Customer"
        ],
        "summary": "Update customer e-invoice registration",
        "description": "Update an existing e-invoice registration for a customer.\n\n**Availability**\n- Markets: Sweden, Italy\n",
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CustomerEinvoiceRegistrationRequest"
              },
              "examples": {
                "Sweden": {
                  "$ref": "#/components/examples/CustomerEinvoiceRegistrationRequestSweden"
                },
                "Italy": {
                  "$ref": "#/components/examples/CustomerEinvoiceRegistrationRequestItaly"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "The customer registration was updated.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "status",
                    "data"
                  ],
                  "properties": {
                    "status": {
                      "type": "string"
                    },
                    "data": {
                      "$ref": "#/components/schemas/CustomerEinvoiceRegistration"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/CustomerNotFound"
          }
        }
      },
      "delete": {
        "operationId": "deleteCustomerEinvoiceRegistration",
        "tags": [
          "Customer"
        ],
        "summary": "Delete customer e-invoice registration",
        "description": "Delete the customer's e-invoice registration.\n\n**Availability**\n- Markets: Sweden, Italy\n",
        "responses": {
          "200": {
            "description": "The customer registration was successfully deleted.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "required": [
                    "status"
                  ],
                  "properties": {
                    "status": {
                      "type": "string",
                      "description": "Operation status."
                    },
                    "data": {
                      "type": "null",
                      "description": "Empty for delete operations."
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/CustomerNotFound"
          }
        }
      }
    },
    "/customer/{customer_no}/billing-tab": {
      "parameters": [
        {
          "$ref": "#/components/parameters/CustomerNo"
        }
      ],
      "get": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "getBillingTab",
        "summary": "Get billing tab",
        "description": "Retrieve the customer's **current billing tab** (the active tab that items are being added to).\n\nThe response includes:\n- `customer.customer_number`\n- `billing_tab.id` and `billing_tab.billing_date`\n- `items[]` with `billogram_item` data\n",
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillingTabDetails"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/customer/{customer_no}/billing-tab/{billing_tab_id}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/CustomerNo"
        },
        {
          "$ref": "#/components/parameters/BillingTabId"
        }
      ],
      "get": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "getBillingTabById",
        "summary": "Get billing tab by ID",
        "description": "Retrieve a **specific billing tab** by its ID.\nThis is useful for accessing historical billing tabs that have been processed.\n",
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillingTabDetails"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "delete": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "deleteBillingTab",
        "summary": "Delete billing tab",
        "description": "Delete a specific billing tab by its ID",
        "responses": {
          "204": {
            "description": "No Content. The billing tab was deleted successfully."
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/customer/{customer_no}/billing-tab/{billing_tab_id}/run": {
      "parameters": [
        {
          "$ref": "#/components/parameters/CustomerNo"
        },
        {
          "$ref": "#/components/parameters/BillingTabId"
        }
      ],
      "post": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "runBillingTab",
        "summary": "Trigger billing tab run",
        "description": "Manually trigger billogram creation for a specific billing tab, instead of\nwaiting for its scheduled billing date.\n\nThe run is processed asynchronously; a **202** response confirms it was accepted.\n",
        "responses": {
          "202": {
            "description": "Accepted. The billing tab run has been queued for processing.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string",
                      "example": "OK"
                    },
                    "data": {
                      "type": "object",
                      "properties": {
                        "status": {
                          "type": "string",
                          "example": "accepted"
                        }
                      }
                    }
                  }
                },
                "examples": {
                  "accepted": {
                    "summary": "Run accepted",
                    "value": {
                      "status": "OK",
                      "data": {
                        "status": "accepted"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabNotFound"
          },
          "409": {
            "$ref": "#/components/responses/BillingTabRunConflict"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/customer/{customer_no}/billing-tab/items": {
      "parameters": [
        {
          "$ref": "#/components/parameters/CustomerNo"
        }
      ],
      "post": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "createBillingTabItem",
        "summary": "Create billing tab item",
        "description": "Add a new item to a customer's billing tab.\n\n### Idempotency (required)\nThis operation requires `X-API-Deduplication-ID` to prevent duplicate items if the request is retried.\n",
        "parameters": [
          {
            "$ref": "#/components/parameters/XApiDeduplicationId"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BillingTabItemCreateRequest"
              },
              "examples": {
                "subscriptionItem": {
                  "summary": "Add a subscription item",
                  "value": {
                    "billogram_item": {
                      "title": "Monthly subscription",
                      "description": "Premium plan subscription",
                      "price": 29.99,
                      "count": 1,
                      "unit": "month",
                      "vat": 25
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillingTabItemCreated"
          },
          "201": {
            "$ref": "#/components/responses/BillingTabItemCreated"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/customer/{customer_no}/billing-tab/item/{billing_tab_item_id}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/CustomerNo"
        },
        {
          "$ref": "#/components/parameters/BillingTabItemId"
        }
      ],
      "get": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "getBillingTabItem",
        "summary": "Get billing tab item",
        "description": "Retrieve a specific billing tab item by ID.\n\nThe API returns the item in its billing-tab context (customer + tab + items).\n",
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillingTabDetails"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabItemNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "delete": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "deleteBillingTabItem",
        "summary": "Delete billing tab item",
        "description": "Delete a specific billing tab item by ID.",
        "responses": {
          "204": {
            "description": "No Content. The billing tab item was deleted successfully."
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabItemNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/customer/{customer_no}/billing-tab/settings": {
      "parameters": [
        {
          "$ref": "#/components/parameters/CustomerNo"
        }
      ],
      "get": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "getBillingTabSettings",
        "summary": "Fetch billing tab settings",
        "description": "Retrieve customer-specific billing tab settings.",
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillingTabSettings"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabSettingsNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "post": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "addBillingTabSettings",
        "summary": "Add billing tab settings",
        "description": "Create or update customer-specific billing settings.\n\n### Rules\n- Provide at least one of `billing_frequency` or `delivery_method`.\n- Set fields to `null` to revert to creditor defaults.\n",
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BillingTabSettingsRequest"
              },
              "examples": {
                "monthlyEmail": {
                  "summary": "Monthly (day 20) via Email",
                  "value": {
                    "billing_frequency": "monthly#20",
                    "delivery_method": "Email"
                  }
                },
                "revertToDefaults": {
                  "summary": "Revert to creditor defaults",
                  "value": {
                    "billing_frequency": null,
                    "delivery_method": null
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillingTabSettings"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabSettingsNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "put": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "updateBillingTabSettings",
        "summary": "Update billing tab settings",
        "description": "Update customer-specific billing settings.\n\nSame rules as POST apply:\n- Provide at least one of `billing_frequency` or `delivery_method`.\n- Set fields to `null` to revert to creditor defaults.\n",
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BillingTabSettingsRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/BillingTabSettings"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabSettingsNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "delete": {
        "tags": [
          "Billing Tab"
        ],
        "operationId": "deleteBillingTabSettings",
        "summary": "Delete customer settings",
        "description": "Delete customer-specific billing settings (so creditor defaults are used).",
        "responses": {
          "204": {
            "description": "No Content. Customer settings deleted successfully."
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/BillingTabSettingsNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/item": {
      "post": {
        "operationId": "createItem",
        "summary": "Create a new item object",
        "description": "This call creates a new item object and returns the created object.\n\nThe item object to be created should be sent in the request body.\n",
        "tags": [
          "Item"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Item"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Item"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "get": {
        "operationId": "listItems",
        "summary": "List/search items",
        "description": "This fetches many item objects, filtered based on optional criteria.\n\nSearchable fields:\n- item_no\n- title\n- description\n- price\n- bookkeeping:income_account\n- bookkeeping:vat_account\n\nSpecial filters:\n- search: Perform a full text search across several fields at once\n\nOrderable fields:\n- item_no\n- title\n- price\n- created_at\n- updated_at\n",
        "tags": [
          "Item"
        ],
        "parameters": [
          {
            "name": "page",
            "in": "query",
            "description": "The result page number to fetch. The first page has number 1 (one).",
            "required": false,
            "schema": {
              "type": "integer",
              "minimum": 1,
              "default": 1
            }
          },
          {
            "name": "page_size",
            "in": "query",
            "description": "How many results to return per page. Setting this number too high may impact performance, we recommend values between 10 and 100.",
            "required": false,
            "schema": {
              "type": "integer",
              "minimum": 1,
              "maximum": 100,
              "default": 25
            }
          },
          {
            "name": "filter_type",
            "in": "query",
            "description": "Type of filtering to perform",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "field",
                "field-prefix",
                "field-search",
                "special"
              ]
            }
          },
          {
            "name": "filter_field",
            "in": "query",
            "description": "Field to filter on when using field-based filtering. Searchable fields include item_no, title, description, price, bookkeeping:income_account, bookkeeping:vat_account.",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "filter_value",
            "in": "query",
            "description": "Value to filter by when using field-based filtering",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "order_field",
            "in": "query",
            "description": "Field to order results by. Orderable fields include item_no, title, price, created_at, updated_at.",
            "required": false,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "order_direction",
            "in": "query",
            "description": "Direction to order results",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "asc",
                "desc"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/ItemList"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/item/{item_no}": {
      "parameters": [
        {
          "name": "item_no",
          "in": "path",
          "description": "Item number identifier",
          "required": true,
          "schema": {
            "type": "string"
          }
        }
      ],
      "get": {
        "operationId": "getItem",
        "summary": "Fetch a single item object",
        "description": "This fetches all data about a single item. The command is sent to the item object.\n",
        "tags": [
          "Item"
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Item"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/ItemNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "put": {
        "operationId": "updateItem",
        "summary": "Update an item object",
        "description": "This command changes an existing item. The command is sent to the item object to modify. This does not affect the item data on any billograms or invoices that reference the item, if the information needs to be updated on any existing billograms those must be updated individually afterwards.\n\nPartial item object, containing just the fields to update.\n\nIf the bookkeeping or regional_sweden fields are left out or set to null (instead of containing the structures) those sub-objects are left unchanged.\n\nOther fields that have default values will be set to their default value if they are specified as null in the passed structure.\n",
        "tags": [
          "Item"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Item"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Item"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/ItemNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "delete": {
        "operationId": "deleteItem",
        "summary": "Delete an item object",
        "description": "This removes an item from the database. The command is sent to the item object to delete. Any billograms or invoices that referenced the item object will have their references cut, but the item data in the billograms and invoices will be left as-is.\n",
        "tags": [
          "Item"
        ],
        "responses": {
          "200": {
            "description": "OK. The item was deleted.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "status": {
                      "type": "string"
                    },
                    "data": {
                      "type": "null",
                      "description": "Empty for delete operations."
                    }
                  }
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/ItemNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/report": {
      "get": {
        "operationId": "listReports",
        "tags": [
          "Report"
        ],
        "summary": "Get multiple reports",
        "description": "Get multiple reports",
        "responses": {
          "200": {
            "description": "successful operation"
          }
        }
      }
    },
    "/report/{filename}": {
      "get": {
        "operationId": "getReport",
        "tags": [
          "Report"
        ],
        "summary": "Get specific report",
        "description": "Get specific reports",
        "responses": {
          "200": {
            "description": "successful operation"
          }
        },
        "parameters": [
          {
            "name": "filename",
            "in": "path",
            "description": "Report filename",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ]
      }
    },
    "/settings": {
      "get": {
        "operationId": "getSettings",
        "summary": "Fetch settings",
        "description": "This fetches the current settings for the Billogram business account. \nIt can be used to fetch the current settings prior to creation of billograms.\n",
        "tags": [
          "Settings"
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Settings"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "put": {
        "operationId": "updateSettings",
        "summary": "Update settings",
        "description": "This changes the current settings for the Billogram business account.\n\nSub-structures that do not need modification can be left out of the object, or be set to `null`.\n",
        "tags": [
          "Settings"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Settings"
              },
              "examples": {
                "partialUpdate": {
                  "summary": "Partial update example",
                  "value": {
                    "contact": {
                      "email": "newemail@example.com"
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Settings"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/payment_source": {
      "get": {
        "summary": "List payment sources for a customer",
        "description": "List payment sources for a customer",
        "tags": [
          "Payment Sources"
        ],
        "operationId": "listPaymentSources",
        "parameters": [
          {
            "name": "customer_no",
            "in": "query",
            "required": true,
            "schema": {
              "type": "integer"
            },
            "description": "The customer number."
          }
        ],
        "responses": {
          "200": {
            "description": "The listing was completed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaymentSourceListResponse"
                }
              }
            }
          },
          "204": {
            "description": "Customer has no mandates"
          },
          "400": {
            "description": "Missing or invalid query parameters"
          },
          "404": {
            "$ref": "#/components/responses/CustomerNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/sepa_dd_mandate": {
      "post": {
        "summary": "Import SEPA Direct Debit mandate for a customer",
        "description": "Import SEPA Direct Debit mandate for a customer",
        "tags": [
          "Payment Sources"
        ],
        "operationId": "importSepaMandate",
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/SepaMandateImport"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Mandate was imported",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SepaMandateImportResponse"
                }
              }
            }
          },
          "400": {
            "description": "Invalid parameter or structure"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/sepa_dd_mandate/migrate": {
      "post": {
        "summary": "Migrate SEPA Direct Debit mandate for a customer",
        "description": "Registers a migrated SEPA Direct Debit mandate for a customer when moving\nfrom a previous creditor. The request carries the existing mandate details\nbeing amended under the `amendment` object; the response returns the\nidentifiers assigned by Billogram.\n\nThe migration is finalized when the first payment is initiated with this\nmigrated mandate.\n",
        "tags": [
          "Payment Sources"
        ],
        "operationId": "migrateSepaMandate",
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/SepaMandateMigration"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Mandate was created with amendments",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SepaMandateMigrationResponse"
                },
                "examples": {
                  "Success": {
                    "value": {
                      "status": "OK",
                      "data": {
                        "customer_no": 1,
                        "iban": "DE89370400440532013000",
                        "signed_date": "2023-02-01",
                        "sepa_creditor_identifier": "DE98ZZZ099999999",
                        "unique_mandate_reference": "87LBRXHD3XY6HM6CDD4L979FBW"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/BadRequestSepaMandateMigrationResponse"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/ForbiddenSepaMandateMigration"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/payment_source/{id}/cancel": {
      "post": {
        "summary": "Cancel a payment source",
        "description": "Cancel a payment source",
        "tags": [
          "Payment Sources"
        ],
        "operationId": "cancelPaymentSource",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "ID of the payment source to cancel"
          }
        ],
        "responses": {
          "200": {
            "description": "The cancellation was completed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaymentSourceCancellationResponse"
                }
              }
            }
          },
          "400": {
            "description": "Invalid parameter or unsupported scheme"
          },
          "404": {
            "description": "Mandate does not exist"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/offer": {
      "post": {
        "operationId": "createOffer",
        "summary": "Create an offer",
        "description": "Creates a new offer and returns the created object.",
        "tags": [
          "Offer"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/OfferCreateRequest"
              },
              "examples": {
                "banner": {
                  "summary": "Banner offer",
                  "value": {
                    "offer_id": "banner001",
                    "type": "banner",
                    "title": "Summer sale!",
                    "text": "30% on everything at Mike's Bike until September.",
                    "info_link": "http://example.com/",
                    "media": {
                      "picture": "iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVR42mNk+M9QDwADhgGAWjR9awAAAABJRU5ErkJggg==",
                      "picture_type": "image/png"
                    }
                  }
                },
                "sale": {
                  "summary": "Sale offer",
                  "value": {
                    "offer_id": "sale001",
                    "type": "sale",
                    "sale_type": "purchase",
                    "title": "Stay safe out there",
                    "text": "Get a helmet for free with your bike purchase.",
                    "detailed_title": "Stay safe while on the road",
                    "detailed_text": "We care about your safety. Whenever you purchase a new bike...",
                    "info_link": "http://example.com/",
                    "terms_link": "http://example.com/terms",
                    "invoice_within_days": 3,
                    "media": {
                      "picture": "iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVR42mNk+M9QDwADhgGAWjR9awAAAABJRU5ErkJggg==",
                      "picture_type": "image/png"
                    },
                    "item": {
                      "type": "physical",
                      "title": "Free bicycle helmet - black",
                      "price": 0,
                      "currency": "SEK",
                      "delivery_within_days": 4,
                      "recurring_cost_type": "none"
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Offer"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "get": {
        "operationId": "listOffers",
        "summary": "List offers",
        "description": "Lists offers with pagination and optional filtering/ordering.\n\n**Note:** The `type` query parameter is required.\n",
        "tags": [
          "Offer"
        ],
        "parameters": [
          {
            "name": "type",
            "in": "query",
            "required": true,
            "description": "Filter offers by type.",
            "schema": {
              "type": "string",
              "enum": [
                "banner",
                "sale"
              ]
            }
          },
          {
            "name": "page",
            "in": "query",
            "required": false,
            "description": "The result page number to fetch. The first page has number 1.",
            "schema": {
              "type": "integer",
              "minimum": 1,
              "default": 1
            }
          },
          {
            "name": "page_size",
            "in": "query",
            "required": false,
            "description": "How many results to return per page.",
            "schema": {
              "type": "integer",
              "minimum": 1,
              "maximum": 100,
              "default": 25
            }
          },
          {
            "name": "filter_type",
            "in": "query",
            "required": false,
            "description": "Type of filtering to perform.",
            "schema": {
              "type": "string",
              "enum": [
                "field",
                "field-prefix",
                "field-search"
              ]
            }
          },
          {
            "name": "filter_field",
            "in": "query",
            "required": false,
            "description": "Field to filter on. Searchable fields include `offer_id` and `title`.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "filter_value",
            "in": "query",
            "required": false,
            "description": "Value to filter by.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "order_field",
            "in": "query",
            "required": false,
            "description": "Field to order results by. Orderable fields include `offer_id` and `title`.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "order_direction",
            "in": "query",
            "required": false,
            "description": "Direction to order results.",
            "schema": {
              "type": "string",
              "enum": [
                "asc",
                "desc"
              ]
            }
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/OfferList"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    },
    "/offer/{offer_id}": {
      "get": {
        "operationId": "getOffer",
        "summary": "Fetch a single offer",
        "description": "Fetch a single offer by `offer_id`.",
        "tags": [
          "Offer"
        ],
        "parameters": [
          {
            "name": "offer_id",
            "in": "path",
            "required": true,
            "description": "Offer identifier.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "$ref": "#/components/responses/Offer"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "404": {
            "$ref": "#/components/responses/OfferNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "put": {
        "operationId": "updateOffer",
        "summary": "Update an offer",
        "description": "Updates an offer. The request body is a **partial** offer object containing only fields to update.\n\n**Note:** If a `sale` offer has been accepted on one or more billograms, updating it is forbidden.\n",
        "tags": [
          "Offer"
        ],
        "parameters": [
          {
            "name": "offer_id",
            "in": "path",
            "required": true,
            "description": "Offer identifier.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/OfferUpdateRequest"
              },
              "examples": {
                "updateTitle": {
                  "summary": "Update title",
                  "value": {
                    "title": "This is an updated title"
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/Offer"
          },
          "400": {
            "$ref": "#/components/responses/BadRequest"
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "403": {
            "$ref": "#/components/responses/Forbidden"
          },
          "404": {
            "$ref": "#/components/responses/OfferNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      },
      "delete": {
        "operationId": "deleteOffer",
        "summary": "Delete an offer",
        "description": "Deletes an offer by `offer_id`.",
        "tags": [
          "Offer"
        ],
        "parameters": [
          {
            "name": "offer_id",
            "in": "path",
            "required": true,
            "description": "Offer identifier.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK. The offer was deleted successfully."
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "404": {
            "$ref": "#/components/responses/OfferNotFound"
          },
          "500": {
            "$ref": "#/components/responses/InternalServerError"
          }
        }
      }
    }
  },
  "webhooks": {
    "BillogramEvent": {
      "post": {
        "operationId": "billogramEventCallback",
        "summary": "BillogramEvent Webhook",
        "description": "Webhook endpoint for receiving Billogram events.\n\nThis endpoint receives webhooks for various events related to Billogram operations. The request body contains event details including the event type and associated data.\n\nFor information about webhook response requirements, request headers, and signature verification, see the Webhooks tag description.\n\n## Event Types\n\nThis webhook can receive various event types. The event type is specified in the `event.type` field of the request body. Use the discriminator to determine which event schema applies.\n",
        "tags": [
          "Webhooks"
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BillogramEventEnvelope"
              },
              "examples": {
                "AutogiroFailed": {
                  "$ref": "#/components/examples/AutogiroFailed"
                },
                "BillogramCreated": {
                  "$ref": "#/components/examples/BillogramCreated"
                },
                "BillogramEnded": {
                  "$ref": "#/components/examples/BillogramEnded"
                },
                "BillogramSent": {
                  "$ref": "#/components/examples/BillogramSent"
                },
[...]
